How to call "if NOT test; then..."


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting How to call "if NOT test; then..."
# 1  
Old 03-16-2009
Question How to call "if NOT test; then..."

Hi there,
I need to do something if a ping fails:
Code:
if ping -c1 192.168.1.1 > /dev/null 2>&1; then :; else
    echo Ping failed
fi

Can't I just do something like:
Code:
if not ping -c1 192.168.1.1 > /dev/null 2>&1; then
    echo Ping failed
fi

Obviously this doesn't work. What's the syntax for if not?
Thanks for your help
Santiago
# 2  
Old 03-17-2009
you have to do something like this...

Code:
ping -c 2 -s 100 -w 1 ipaddress >/dev/null
if [ $? -eq 1 ] ; then
echo "ping failed"
else
echo "pinging"
fi

# 3  
Old 03-17-2009
Code:
$ ping 192.168.1.1
no answer from 192.168.1.1

$ if ! ping -c1 192.168.1.1 > /dev/null 2>&1; then
> echo ping failed
> fi
ping failed

$ ping 10.68.64.122
10.68.64.122 is alive

$ if ! ping -c1 10.68.64.122 > /dev/null 2>&1; then
> echo ping failed
> fi
$

# 4  
Old 03-17-2009
Thanks vidyadhar for your time and help.
Thanks rikxik for your prop, that's exactly what I was looking for.
# 5  
Old 03-17-2009
If you are using ksh, you can use the short circuit operator:

Code:
ping -c1 192.168.1.1 > /dev/null 2>&1 || echo "ping failed"

# 6  
Old 03-17-2009
Thanks rikxik,
I knew this short circuit and I'm using it with bash.
But I needed your syntax because I have several lines in the if then.
Login or Register to Ask a Question

Previous Thread | Next Thread

9 More Discussions You Might Find Interesting

1. AIX

Apache 2.4 directory cannot display "Last modified" "Size" "Description"

Hi 2 all, i have had AIX 7.2 :/# /usr/IBMAHS/bin/apachectl -v Server version: Apache/2.4.12 (Unix) Server built: May 25 2015 04:58:27 :/#:/# /usr/IBMAHS/bin/apachectl -M Loaded Modules: core_module (static) so_module (static) http_module (static) mpm_worker_module (static) ... (3 Replies)
Discussion started by: penchev
3 Replies

2. Shell Programming and Scripting

Bash script - Print an ascii file using specific font "Latin Modern Mono 12" "regular" "9"

Hello. System : opensuse leap 42.3 I have a bash script that build a text file. I would like the last command doing : print_cmd -o page-left=43 -o page-right=22 -o page-top=28 -o page-bottom=43 -o font=LatinModernMono12:regular:9 some_file.txt where : print_cmd ::= some printing... (1 Reply)
Discussion started by: jcdole
1 Replies

3. UNIX for Dummies Questions & Answers

Using "mailx" command to read "to" and "cc" email addreses from input file

How to use "mailx" command to do e-mail reading the input file containing email address, where column 1 has name and column 2 containing “To” e-mail address and column 3 contains “cc” e-mail address to include with same email. Sample input file, email.txt Below is an sample code where... (2 Replies)
Discussion started by: asjaiswal
2 Replies

4. Shell Programming and Scripting

Shc : trying to test functionality "test" compiling but can not execute

I am testing shc to see if it would help with my need. Im at a point where Im trying to compile and test the "test.ksh" file that comes in the tar ball : shc-3.8.9> shc -v -r -f test.ksh shc shll=ksh shc =-c shc =exec '%s' "$@" shc = shc opts= shc: cc test.ksh.x.c -o test.ksh.x... (7 Replies)
Discussion started by: popeye
7 Replies

5. UNIX for Dummies Questions & Answers

What is the significance of sh -s in ssh -qtt ${user}@${host} "sh -s "${version}"" < test.sh?

Please can you help me understand the significance of providing arguments under sh -s in > ssh -qtt ${user}@${host} "sh -s "${version}"" < test.sh (4 Replies)
Discussion started by: Sree10
4 Replies

6. Shell Programming and Scripting

Test command with "-z" and "-n"

Hello all, Please let me know, why the value of $? is diff for -z and -n. And explain what are the operends we can use with "test" and their purpose.. $ test -z "" $ echo $? 0 $ test -n "" $ echo $? 1 Thanx in advance.. (2 Replies)
Discussion started by: divya bandipotu
2 Replies

7. Shell Programming and Scripting

awk command to replace ";" with "|" and ""|" at diferent places in line of file

Hi, I have line in input file as below: 3G_CENTRAL;INDONESIA_(M)_TELKOMSEL;SPECIAL_WORLD_GRP_7_FA_2_TELKOMSEL My expected output for line in the file must be : "1-Radon1-cMOC_deg"|"LDIndex"|"3G_CENTRAL|INDONESIA_(M)_TELKOMSEL"|LAST|"SPECIAL_WORLD_GRP_7_FA_2_TELKOMSEL" Can someone... (7 Replies)
Discussion started by: shis100
7 Replies

8. UNIX for Dummies Questions & Answers

Explain the line "mn_code=`env|grep "..mn"|awk -F"=" '{print $2}'`"

Hi Friends, Can any of you explain me about the below line of code? mn_code=`env|grep "..mn"|awk -F"=" '{print $2}'` Im not able to understand, what exactly it is doing :confused: Any help would be useful for me. Lokesha (4 Replies)
Discussion started by: Lokesha
4 Replies

9. Programming

error "Invalid argument" returned after call sched_setscheduler

the code is below and the was run on Solaris 9. ----------------------------- struct sched_param param; param.sched_priority = 99; if(sched_setscheduler(0, SCHED_RR, &param) == -1) { perror("setting priority"); exit(1); } ------------------------------- after the... (1 Reply)
Discussion started by: robin.zhu
1 Replies
Login or Register to Ask a Question